import numpy as np
import pandas as pd
import matplotlib as mpl
import matplotlib.pyplot as plt
import seaborn as sns

steps = 100

sns.set(style='ticks')

t = []
for i in range(steps+1):
	t.append(i/steps)
print(t)

b1_0 = []
b1_1 = []
b2_0 = []
b2_1 = []
b2_2 = []
b3_0 = []
b3_1 = []
b3_2 = []
b3_3 = []
for i in t:
	b1_0.append(1-i)
	b1_1.append(i)
	b2_0.append((1-i)*(1-i))
	b2_1.append(2*i*(1-i))
	b2_2.append(i*i)
	b3_0.append((1-i)*(1-i)*(1-i))
	b3_1.append(3*i*(1-i)*(1-i))
	b3_2.append(3*i*i*(1-i))
	b3_3.append(i*i*i)

b1 = pd.DataFrame({'$B_0$': b1_0, '$B_1$': b1_1}, index=t)
b2 = pd.DataFrame({'$B_0$': b2_0, '$B_1$': b2_1, '$B_2$': b2_2}, index=t)
b3 = pd.DataFrame({'$B_0$': b3_0, '$B_1$': b3_1, '$B_2$': b3_2, '$B_3$': b3_3}, index=t)

plt.figure(1)
sns.set_palette(sns.husl_palette(2, 0.01)[1:])
p = sns.lineplot(data=b1, dashes=False)
p.axes.set_xlim(0,1)
p.axes.set_ylim(0,1)
plt.xlabel('$t$')
plt.ylabel('weight')
plt.xticks([0, 1])
plt.yticks([0, 1])
# plt.show()
plt.savefig('/Users/ken/Desktop/bernstein1.pdf', format='pdf')

plt.figure(2)
sns.set_palette(sns.husl_palette(3, 0.01)[1:])
p = sns.lineplot(data=b2, dashes=False)
p.axes.set_xlim(0,1)
p.axes.set_ylim(0,1)
plt.xlabel('$t$')
plt.ylabel('weight')
plt.xticks([0, 0.5, 1])
plt.yticks([0, 1])
# plt.show()
plt.savefig('/Users/ken/Desktop/bernstein2.pdf', format='pdf')

plt.figure(3)
sns.set_palette(sns.husl_palette(4, 0.01)[1:])
p = sns.lineplot(data=b3, dashes=False)
p.axes.set_xlim(0,1)
p.axes.set_ylim(0,1)
plt.xlabel('$t$')
plt.ylabel('weight')
plt.xticks([0, 1/3, 2/3, 1])
plt.yticks([0, 1])
# plt.show()
plt.savefig('/Users/ken/Desktop/bernstein3.pdf', format='pdf')