import numpy as np
import pandas as pd
import matplotlib as mpl
import matplotlib.pyplot as plt
from mpl_toolkits.mplot3d import axes3d
import seaborn as sns

sns.set(style='ticks')

cpx = np.arange(0, 1.01, 1/3)
cpy = np.arange(0, 1.01, 1/3)
cpx, cpy = np.meshgrid(cpx, cpy)
cp = np.array([[0.0, 0.2, 0.3, 0.1], 
	             [-0.3, 0.4, -0.25, 0.4], 
	             [0.3, -0.2, -0.1, 0.25], 
	             [0.1, -0.5, -0.3, 0.0]])
# print(cp)

sx = np.arange(0, 1.001, 0.01)
sy = np.arange(0, 1.001, 0.01)
sx, sy = np.meshgrid(sx, sy)
s = np.zeros((101, 101))
for xi in range(len(sx)):
	for yi in range(len(sy)):
		x = sx[xi][yi]
		y = sy[xi][yi]
		s[xi][yi] = (1-x)*(1-x)*(1-x)*(1-y)*(1-y)*(1-y)*cp[0][0] + \
		            (1-x)*(1-x)*(1-x)*3*y*(1-y)*(1-y)*cp[1][0] + \
		            (1-x)*(1-x)*(1-x)*3*y*y*(1-y)*cp[2][0] + \
		            (1-x)*(1-x)*(1-x)*y*y*y*cp[3][0] + \
		            3*x*(1-x)*(1-x)*(1-y)*(1-y)*(1-y)*cp[0][1] + \
		            3*x*(1-x)*(1-x)*3*y*(1-y)*(1-y)*cp[1][1] + \
		            3*x*(1-x)*(1-x)*3*y*y*(1-y)*cp[2][2] + \
		            3*x*(1-x)*(1-x)*y*y*y*cp[3][1] + \
		            3*x*x*(1-x)*(1-y)*(1-y)*(1-y)*cp[0][2] + \
		            3*x*x*(1-x)*3*y*(1-y)*(1-y)*cp[1][2] + \
		            3*x*x*(1-x)*3*y*y*(1-y)*cp[2][2] + \
		            3*x*x*(1-x)*y*y*y*cp[3][2] + \
		            x*x*x*(1-y)*(1-y)*(1-y)*cp[0][3] + \
		            x*x*x*3*y*(1-y)*(1-y)*cp[1][3] + \
		            x*x*x*3*y*y*(1-y)*cp[2][3] + \
		            x*x*x*y*y*y*cp[3][3]
# 		s[xi][yi] = (1-x)*(1-x)*(1-y)*(1-y)*cp[0][0] + (1-x)*(1-x)*2*y*(1-y)*cp[1][0] + (1-x)*(1-x)*y*y*cp[2][0] + \
#                 2*x*(1-x)*(1-y)*(1-y)*cp[0][1] + 2*x*(1-x)*2*y*(1-y)*cp[1][1] + 2*x*(1-x)*y*y*cp[2][1] + \
#                 x*x*(1-y)*(1-y)*cp[0][2] + x*x*2*y*(1-y)*cp[1][2] + x*x*y*y*cp[2][2]

fig = plt.figure(num=1, figsize=(15, 6), dpi=200)
ax = fig.add_subplot(111, projection='3d')
ax.plot_wireframe(cpx, cpy, cp, color='black')
surf = ax.plot_surface(sx, sy, s, linewidth=0.1, alpha=0.7)
ax.axes.set_xlim(0,1)
ax.axes.set_ylim(0,1)
ax.axes.set_zlim(-0.5,.5)
ax.view_init(elev=58, azim=-30)
# plt.show()
plt.savefig('/Users/ken/Desktop/cubicsurf.png', format='png')