import numpy as np
import pandas as pd
import matplotlib as mpl
import matplotlib.pyplot as plt
from mpl_toolkits.mplot3d import axes3d
import seaborn as sns

sns.set(style='ticks')

x = [0.0, 1/3, 2/3, 1.0, 1/6, 3/6, 5/6, 1/3, 2/3, 1/2]
y = [0.0, 0.0, 0.0, 0.0, 0.29, 0.29, 0.29, 0.58, 0.58, 0.87]
z = [0.0, 0.2, -0.2, 0.0, 0.3, 0.2, -0.2, -0.3, -0.1, 0.0]

xu = x[3]
yu = y[3]
zu = z[3]
xv = x[9]
yv = y[9]
zv = z[9]
xw = x[0]
yw = y[0]
zw = z[0]
# u = [0.0, 0.5, 1.0, 0.0, 0.5, 0.0]
# v = [0.0, 0.0, 0.0, 0.5, 0.5, 1.0]
# w = [1.0, 0.5, 0.0, 0.5, 0.0, 0.0]

sx = []
sy = []
sz = []
for sxp in np.arange(0, 1.001, 1/100):
	for syp in np.arange(0, 1.001, 1/100):
		if sxp+syp <= 1.0:
			sx.append(sxp+(syp)*0.5)
			sy.append(syp*0.87)
			u = ((yv-yw)*(sx[-1]-xw)+(xw-xv)*(sy[-1]-yw))/((yv-yw)*(xu-xw)+(xw-xv)*(yu-yw))
			v = ((yw-yu)*(sx[-1]-xw)+(xu-xw)*(sy[-1]-yw))/((yv-yw)*(xu-xw)+(xw-xv)*(yu-yw))
			w = 1-u-v
			sz.append(w*w*w*z[0] + 3*u*w*w*z[1] + 3*u*u*w*z[2] + u*u*u*z[3] + \
				        3*v*w*w*z[4] + 6*u*v*w*z[5] + 3*u*u*v*z[6] + \
				        3*v*v*w*z[7] + 3*u*v*v*z[8] + \
				        v*v*v*z[9])

# print(sz)

fig = plt.figure(num=1, figsize=(12, 6), dpi=300)
ax = fig.add_subplot(111, projection='3d')
ax.plot_trisurf(x, y, z, alpha=0, edgecolors='black')
ax.plot_trisurf(sx, sy, sz, linewidth=0, alpha=0.7)
ax.axes.set_xlim(0,1)
ax.axes.set_ylim(0,1)
ax.axes.set_zlim(-0.5,0.5)
ax.view_init(elev=41, azim=-57)
# plt.show()
plt.savefig('/Users/ken/Desktop/cubictri.png', format='png')