import numpy as np
import pandas as pd
import matplotlib as mpl
import matplotlib.pyplot as plt
from mpl_toolkits.mplot3d import axes3d
import seaborn as sns

sns.set(style='ticks')

x = [0.0, 0.5, 1.0, 0.25, 0.75, 0.5]
y = [0.0, 0.0, 0.0, 0.43, 0.43, 0.86]
z = [0.0, 0.2, 0.1, 0.15, 0.3, 0.05]

xu = x[2]
yu = y[2]
zu = z[2]
xv = x[5]
yv = y[5]
zv = z[5]
xw = x[0]
yw = y[0]
zw = z[0]
# u = [0.0, 0.5, 1.0, 0.0, 0.5, 0.0]
# v = [0.0, 0.0, 0.0, 0.5, 0.5, 1.0]
# w = [1.0, 0.5, 0.0, 0.5, 0.0, 0.0]

sx = []
sy = []
sz = []
for sxp in np.arange(0, 1.001, 1/100):
	for syp in np.arange(0, 1.001, 1/100):
		if sxp+syp <= 1.0:
			sx.append(sxp+(syp)*0.5)
			sy.append(syp*0.86)
			u = ((yv-yw)*(sx[-1]-xw)+(xw-xv)*(sy[-1]-yw))/((yv-yw)*(xu-xw)+(xw-xv)*(yu-yw))
			v = ((yw-yu)*(sx[-1]-xw)+(xu-xw)*(sy[-1]-yw))/((yv-yw)*(xu-xw)+(xw-xv)*(yu-yw))
			w = 1-u-v
			sz.append(w*w*z[0] + 2*u*w*z[1] + u*u*z[2] + \
			          2*v*w*z[3] + 2*u*v*z[4] + \
			          v*v*z[5])

# print(sz)

fig = plt.figure(num=1, figsize=(12, 6), dpi=300)
ax = fig.add_subplot(111, projection='3d')
ax.plot_trisurf(x, y, z, alpha=0, edgecolors='black')
ax.plot_trisurf(sx, sy, sz, linewidth=0, alpha=0.7)
ax.axes.set_xlim(0,1)
ax.axes.set_ylim(0,1)
ax.axes.set_zlim(0,0.5)
ax.view_init(elev=57, azim=-50)
# plt.show()
plt.savefig('/Users/ken/Desktop/quadratictri.png', format='png')